import { ZdComponentRender } from '@zeedhi/vuetify';
import { Component } from 'vue-property-decorator';
import { Calendar } from './Calendar';

@Component
export default class ZdCalendar extends ZdComponentRender {
  public instance!: Calendar;

  public instanceType: typeof Calendar = Calendar;

  public selectedElement?: any = null;

  public selectedEvent?: Object = {};

  public selectedOpen?: Boolean = false;

  public value?: string = '';

  public title: string = this.resturnMonth((new Date()).getMonth());

  public startPeriod?: string;

  public endPeriod?: string;

  public cards?: Array<Object> = [];

  public overlapType = 'stack';

  public types?: Array<Object> = [
    // 'month', 'week', 'day'
    {
      txt: 'Mês',
      val: 'month',
    },
    {
      txt: 'Semana',
      val: 'week',
    },
    {
      txt: 'Dia',
      val: 'day',
    },
  ];

  public focusC: string = '';

  protected resturnMonth(componente: any): string {
    return ['Janeiro', 'Fevereiro', 'Março', 'Abril', 'Maio', 'Junho', 'Julho', 'Agosto', 'Setembro', 'Outubro', 'Novembro', 'Dezembro'][componente];
  }

  protected getTitle() {
    return this.title;
  }

  public setToday() {
    this.instance.value = '';
  }

  public setDate(data: any) {
    this.instance.startPeriod = data.start.date;
    this.instance.endPeriod = data.end.date;
    if (this.instance.type === 'week' && this.instance.startPeriod!.split('-')[1] !== this.instance.endPeriod!.split('-')[1]) {
      this.title = `${this.resturnMonth(Number(this.instance.startPeriod!.split('-')[1]) - 1)} - ${this.title = this.resturnMonth(Number(this.instance.endPeriod!.split('-')[1]) - 1)}`;
    } else {
      this.title = this.resturnMonth(Number(this.instance.startPeriod!.split('-')[1]) - 1);
    }
    this.instance.change();
  }

  public viewDay({ date }:any) {
    this.instance.value = date;
    this.instance.type = 'day';
  }

  public clickOnEvent(dados: any) {
    this.instance.clickOnEvent(dados.event);
    this.viewDay(dados.day);
  }
}
